Subject: [PATCHv2] Add details about svn-fe's dumpfile parsing

From: Andrew Sayers <[email-masked]>
Date: Sun, 15 Apr 2012 17:10:46 +0100

The documentation for the SVN dumpfile format says that "property key/value
pairs may be interpreted as binary data in any encoding by client tools".
Documenting svn-fe's interpretation helps authors of related tools, while
explaining limitations helps ordinary users import their SVN repositories.

The "INPUT FORMAT" section is aimed at authors of tools that interact with
svn-fe, so it particularly addresses assumptions that authors might make after
dealing with svn itself.

The "BUGS" section is aimed at ordinary users, so it only explains what readers
need to know when importing a repository.  In particular, users don't need to
know that other characters in the range 0x01-0x1F are imported correctly, even
though they were all disabled in Subversion 1.2.0.  The text in this section is
based largely on an example sent by Jonathan Nieder, with minor changes to suit
the surrounding style.

Signed-off-by: Andrew Sayers <[email-masked]>
---
 contrib/svn-fe/svn-fe.txt |   13 +++++++++++++
 1 files changed, 13 insertions(+), 0 deletions(-)

diff --git a/contrib/svn-fe/svn-fe.txt b/contrib/svn-fe/svn-fe.txt
index 1128ab2..3872b9d 100644
--- a/contrib/svn-fe/svn-fe.txt
+++ b/contrib/svn-fe/svn-fe.txt
@@ -32,6 +32,13 @@ Subversion's repository dump format is documented in full in
 Files in this format can be generated using the 'svnadmin dump' or
 'svk admin dump' command.
 
+Unlike Subversion, 'svn-fe' interprets property key/value pairs as
+null-terminated binary strings.  This means it will accept content
+that Subversion normally wouldn't produce (such as filenames
+containing tab characters) or would refuse to parse (such as usernames
+containing Latin-1 characters).  However, like Subversion it will
+handle newlines incorrectly in filenames (see BUGS below).
+
 OUTPUT FORMAT
 -------------
 The fast-import format is documented by the git-fast-import(1)
@@ -65,6 +72,12 @@ Empty directories and unknown properties are silently discarded.
 
 The exit status does not reflect whether an error was detected.
 
+Due to limitations in the Subversion dumpfile format, 'svn-fe' does
+not support filenames with newlines.  'svn add' has forbidden such
+filenames since version 1.2.0, but some historical repositories still
+contain them.  An import can appear to succeed and produce incorrect
+results when such pathological filenames are present.
+
 SEE ALSO
 --------
 git-svn(1), svn2git(1), svk(1), git-filter-branch(1), git-fast-import(1),
-- 
1.7.1